﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Web;
using System.Web.Script;
using System.Web.Script.Serialization;
using System.Net;
using Twitterizer.Framework;

namespace TweetBrando
{
    public partial class TrendingView : Form
    {
        public static string topic;

        public TrendingView(string inputTopic)
        {
            topic = inputTopic;
            if (topic[0] == '#')
                topic = topic.Replace("#", @"%23");
            InitializeComponent();
        }

        private void FriendTimeline_Load(object sender, EventArgs e)
        {
            try
            {
                Results[] results = doSearch(topic);

                lTweet1.Text = results[0].from_user;
                pTweet1.ImageLocation = results[0].profile_image_url;
                tTweet1.Text = results[0].text;
                lTweet2.Text = results[1].from_user;
                pTweet2.ImageLocation = results[1].profile_image_url;
                tTweet2.Text = results[1].text;
                lTweet3.Text = results[2].from_user;
                pTweet3.ImageLocation = results[2].profile_image_url;
                tTweet3.Text = results[2].text;
                lTweet4.Text = results[3].from_user;
                pTweet4.ImageLocation = results[3].profile_image_url;
                tTweet4.Text = results[3].text;
                lTweet5.Text = results[4].from_user;
                pTweet5.ImageLocation = results[4].profile_image_url;
                tTweet5.Text = results[4].text;
                lTweet6.Text = results[5].from_user;
                pTweet6.ImageLocation = results[5].profile_image_url;
                tTweet6.Text = results[5].text;
                lTweet7.Text = results[6].from_user;
                pTweet7.ImageLocation = results[6].profile_image_url;
                tTweet7.Text = results[6].text;
                lTweet8.Text = results[7].from_user;
                pTweet8.ImageLocation = results[7].profile_image_url;
                tTweet8.Text = results[7].text;
                lTweet9.Text = results[8].from_user;
                pTweet9.ImageLocation = results[8].profile_image_url;
                tTweet9.Text = results[8].text;
                lTweet10.Text = results[9].from_user;
                pTweet10.ImageLocation = results[9].profile_image_url;
                tTweet10.Text = results[9].text;
                lTweet11.Text = results[10].from_user;
                pTweet11.ImageLocation = results[10].profile_image_url;
                tTweet11.Text = results[10].text;
                lTweet12.Text = results[11].from_user;
                pTweet12.ImageLocation = results[11].profile_image_url;
                tTweet12.Text = results[11].text;
                
            }
            catch
            {
                throw;
            }
            
        }

        public Results[] doSearch(string search)
        {
            string tempstring = null;
            int count = 0;
            StringBuilder sb = new StringBuilder();
            byte[] buf = new byte[9000];

            HttpWebRequest req = (HttpWebRequest)WebRequest.Create("http://search.twitter.com/search.json?q="+search);
            req.UserAgent = "TweetBrando";
            HttpWebResponse resp = (HttpWebResponse)req.GetResponse();
            Stream respStream = resp.GetResponseStream();

            do
            {
                count = respStream.Read(buf, 0, buf.Length);

                if (count != 0)
                {
                    tempstring = Encoding.ASCII.GetString(buf,0,count);
                    sb.Append(tempstring);
                }
            } while (count > 0);

            string jSON = sb.ToString();

            JavaScriptSerializer deser = new JavaScriptSerializer();
            Search search_Deserialized = deser.Deserialize<Search>(jSON); 
            respStream.Close();

            return search_Deserialized.results;
        }
    }

    public class Search
    {
        public Results[] results { get; set; }
    }

    public class Results
    {
        public string text { get; set; }
        public string from_user { get; set; }
        public string profile_image_url { get; set; }
    }
}
